; RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=reprofiler.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseAnsi=n
#AutoIt3Wrapper_Res_Description=Profile-association Repair Tool
#AutoIt3Wrapper_Res_Fileversion=2.0.1.1
#AutoIt3Wrapper_Res_Comment=http://iwrconsultancy.co.uk
#AutoIt3Wrapper_Res_Productversion=1.2 
;#AutoIt3Wrapper_Res_Language=English
#AutoIt3Wrapper_Res_LegalCopyright=IWR Consultancy, GPL v3
#AutoIt3Wrapper_Run_AU3Check=n
#AutoIt3Wrapper_Res_Icon_Add=d:\autoit\!projects\reprofiler\help.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; ReProfiler
; Released by IWR Consultancy, under the GPL licence, v3.
; Instructions for use at: http://iwrconsultancy.co.uk/reprofiler

#cs
Changelog:
v2.0
Recompile with Autoit 3.3.14.2
Library includes updated
Progress indicator added
Patreon link added
Elimination of 1000-user limit
Performance improvements with large userbases
Windows 10 reattach (but not reassign) capability
v1.1
Recompile with Autoit 3.3.12.0
v0.5-1.0
Changes to profile ownership logic.
Improved profile-linking registry code. 
Added logon test function.
Warnings added for several inadvisable profile changes.
Syntax changes to suit later SetACL versions.
Preliminary testing with Windows 8. 
3381 AutoIt compiler and libs. 
v0.4->0.5
Recompile, new libs.
v0.3->0.4
No major changes
Declared as beta version, no bug reports since 0.3 
Startup warning message removed
Help button added
v0.2->0.3
Now using 3.3.6.1 compiler and libraries, eliminates intermittent WMI bug causing "Error in line -1" message. Or, at least I hope it does!
Temporary registry SID assigned when account's hive is already in use, overcomes inability to set registry permissions in some circumstances.
Improved logic for handling changes to the active useraccount.
Using ICACLS to set filesystem permissions on Vista/7, as this handles the cyclic junctions better. Permissions are now set recursively on all supported OS's. 
v0.1->0.2
Compiled with Autoit 3.3.0.0
New method of profile assignment, works in more situations. 
Several obscure problems with setting of registry-permissions fixed.
Erase Data now works for Windows 7.
Assignment of active user's profile now possible. 
(In most cases it is no longer necessary to logon as another user to change your own assignment)
Added detection of an attempt to delete the active profile. 
Properties panel is more informative.
#ce

opt ("TrayAutoPause",0)
opt ("TrayIconHide",1)
; #include "directives.au3"
#include <GUIConstants.au3>
#include <WinAPI.au3>
#include <Security.au3>
; Credit for these libraries goes to the AutoIt developers esp Paul Campbell, Trancexx, JPM, Valik.  

global $appVersion = "2.0"
global $doswindow=@SW_MINIMIZE
global $useXCACLS=0

; Added 2.0 for au3chk consistency..
global $profileRoot=""
global $profDirs[10000]
global $users[10000][8]

if $cmdLine[0]>0 then
 if $cmdLine[1]="/logontest" then 
  ShowTestLogon()
  exit  
 endif
endif

$ComputerDomain = GetComputerDomain()
if $ComputerDomain=@computername then 
 $domainComputer=false
else
 $domainComputer=true
endif

if FileExists(@scriptdir & "\setacl.exe")=0 then
  local $msg=msgbox(52,"Missing Dependency","This utility requires setacl.exe to be present in its own folder. Without this, some functionality may not work correctly. Do you wish to continue without it?")
  if $msg<>6 then exit
endif

if stringinstr($appVersion,"a") then
  msgbox(48,"Development version " & $appVersion," Please be aware that this is a minimally tested release. It is therefore not advisable to use it in a production role. The latest production release is preferred for any mission-critical work.")
endif
if stringinstr($appVersion,"b") then
  msgbox(48,"Development version " & $appVersion," Please be aware that this is a pre-production release. Whilst this version has been tested quite extensively, it has not yet been deployed in the field or used in real IT-support scenarios. Therefore, please use with caution and always back-up your data.")
endif

if (@OSVersion='WIN_10') then 
msgbox(48,"Reprofiler and Windows 10", "This version is capable of reattaching a Windows 10 profile to its original user account, from which it has become detached, in other words it can fulfil the most usual repair requirement. "& @crlf & @crlf &" It is not, however, advisable to use this version to change the ownership of a Windows 10 profile, for example from a standalone account to a domain account."& @crlf & @crlf &" Issues which may arise with user changes are no Start Menu or Control Panel, or inability to elevate permissions." & @crlf & @crlf & "This situation is due to a combination of factors involving registry permissions and Metro app XML registration. A solution is being developed, but owing to the complexity of the requirements it may demand considerable development and testing time.")
endif

global $logfile=@TempDir & "\ProfileReassignment.log"
if FileExists($logfile) then FileDelete($logfile)
$showSysItems=0
$showBy = "User Account"
$lvProfiles=-1
$lvUsers=-1
$prMode="user"

$SystemFolders="|Default User|All Users|NetworkService|LocalService|__sbs_netsetup__|"
$SystemUsers="|Default User|All Users|SBS Backup User|HelpAssistant|Administrator Tmpl|Power User Tmpl|guest|"

global $allowDelete="YES"
getprofiles()
getusers()

if $users[0][7]>0 then
 $roamwarn=" Some accounts on this system have a roaming profile. Please ensure you have read and understood the manual section regarding the reassignment of local profiles where roaming profiles exist. Incorrect usage here could result in data corruption."  
else
 $roamwarn=""
endif


if NOT IsAdmin() then
  $UAEEnabled= RegRead("HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Policies\System", "EnableLUA")
  $adminmsg="For best results, restart the computer and log on with an Administrator account as the ONLY active user." 
if $domainComputer then   
    $adminmsg=$adminmsg & @cr & "For Active Directory computers this should be a domain account with at least local Administrator rights."
    if $roamwarn <> "" then $adminmsg = $adminmsg & @crlf & " Additionally, " & $roamwarn 
endif
if $UAEEnabled then     
    $adminmsg=$adminmsg & @cr & "You may elevate this process if you wish, but it is preferable to work as a real Administrator. Elevate process?"  
endif 
  local $msg=msgbox(52,"Running as limited-rights User",$adminmsg)
  if $msg<>6 then exit
  Run(@scriptdir & "\elevate.exe")
  exit
else
  if ($domainComputer) and (EnvGet("USERDOMAIN")=@computerName) then   
    $adminmsg="This appears to be an Active Directory computer, but you are logged on with a local account. To see domain account profile information, restart and log on with a domain account having at least local Administrator rights."
  if $roamwarn <> "" then $adminmsg = $adminmsg & @crlf & " Additionally, " & $roamwarn 
    local $msg=msgbox(0,"Active Directory Member Computer",$adminmsg)
  else
    if $roamwarn <> "" then msgbox(0,"Active Directory Member Computer",$roamwarn)
  endif
endif
$adminmsg=""
$roamwarn=""

global $dirtyData=1 ; We got the data already, but we need to paint-in the GUI on first run.
; 0 no action, 1 repaint GUI only, 2 reload data and repaint GUI.

$ProfGUI=GUICreate("Profiles in: " & $profileroot,550,550,100,200,-1)

$img1=GUICtrlCreateIcon(@ScriptFullPath,-1,16,7,48,48)
$Label1 = GUICtrlCreateLabel("ReProfiler", 74, 14, 249, 40)
GUICtrlSetFont(-1, 24, 800, 2, "Arial")
$Label5 = GUICtrlCreateLabel($appVersion, 234, 34, 20, 20)
GUICtrlSetFont(-1, 7)
$Label2 = GUICtrlCreateLabel("Profile Link Repair Tool", 340, 18, 120, 17)
$Label4 = GUICtrlCreateLabel("By IWR Consultancy", 380, 38, 102, 17)

$inpSysItems=GUICtrlCreateCheckbox("Show System Items",70,235)
GUICtrlSetTip ( $inpSysitems, "If checked, operating system accounts and profiles are shown along with users" )
if $showSysItems then GuiCtrlSetState($inpSysItems,1)

; $lblHelp= GUICtrlCreateLabel("Website", 360, 238, 99, 17)
; $btnHelp = GUICtrlCreateButton("Website",380,233,110,26)
; GUICtrlSetColor ( $btnPatreon, 0x0000a0 )
; GuiCtrlSetImage($btnHelp,@ScriptFullPath,201)
; GUICtrlSetTip ( $btnHelp, "Opens the instructions page in your Web browser" )

$btnProperties=GuiCtrlCreateButton("Properties", 30, 450, 110, 30)
GUICtrlSetTip ( $btnProperties, "Lists properties of selected user and profile" & @crlf & " (please select both first)" )
$btnExit=GuiCtrlCreateButton("Exit", 30, 500, 110, 30)
GUICtrlSetTip ( $btnExit, "Leave program, discarding any unprocessed changes" )
$btnAssign=GuiCtrlCreateButton("Assign", 180, 450, 110, 30)
GUICtrlSetTip ( $btnAssign, "Assign the selected profile folder to the selected user" )
$btnDetach=GuiCtrlCreateButton("Detach", 180, 500, 110, 30)
GUICtrlSetTip ( $btnDetach, "The selected user will be dissociated from their existing profile" & @crlf & " No data will be deleted, but the user may not be able to log on afterwards" )
$btnDelete=GuiCtrlCreateButton("Erase Data", 320, 500, 110, 30)
GUICtrlSetTip ( $btnDelete, "PERMANENTLY delete the contents of the selected folder in profile list" )
$btnRefresh=GuiCtrlCreateButton("Refresh Views", 320, 450, 110, 30)
GUICtrlSetTip ( $btnRefresh, "Reload the user and profile information," & @crlf & " if these have been changed by another program" )
$btnTest=GuiCtrlCreateButton("Test", 460, 450, 60, 30)
GUICtrlSetTip ( $btnTest, "Test a user's logon to determine whether" & @crlf & " the logon and profile association work correctly" )
$btnHelp=GuiCtrlCreateButton("Help", 460, 500, 60, 30)
GUICtrlSetTip ( $btnHelp, "Visit our website to read the instruction manual" )

$lblUserList = GuiCtrlCreateLabel("User Accounts:", 240, 50, 105, 20)
$lblProfileList = GuiCtrlCreateLabel("Profile Folders:", 240, 250, 105, 20)


do ; Main UI loop
  if $dirtyData = 2 then
    if $users[0][0]>100 then 
      $dirtyData=0
      $msg=msgbox(32,"Reprofiler","In order to avoid undue waiting time where several profile changes are required to this large directory, the displayed information has not been refreshed. Press the Refresh Views button when you need to see the current status of all users." ,5)
    endif
  endif
  if $dirtyData > 1 then
    ; reload data
      ProgressOn ( "Reprofiler", "Retrieving profile list","Please wait.." )
      getprofiles()
      ProgressSet ( "Reprofiler", "Retrieving user list","Please wait.." )
      getusers()
  endif
  if $dirtyData > 0 then
    ProgressOn ( "Reprofiler", "Collating data for display","Compiling profile list.." )
    ; refill GUI values
    dim $plv[$profdirs[0]+1]
    $lvSize = $profdirs[0] + $users[0][0] + 2 
    dim $lvCtrl[$lvSize]
    ; msgbox(0,"Database size",$users[0][0] & " users" & @crlf & @crlf & $profdirs[0] & "profile folders",2)
    $lvCtrl[0]=0
    if $lvProfiles<>-1 then
      GUICtrlDelete($lvProfiles)
    endif

    $lvProfiles = GUICtrlCreateListView (" Data Folder  |               Assigned User(s)         ",10,270,530,150);,$LVS_SORTDESCENDING)

    for $ct=1 to $profdirs[0]
      ProgressSet((100*$ct)/$profdirs[0])
      $lvVarlist=$profdirs[$ct]
      if $showSysItems=0 and stringinstr($systemFolders,"|" & filename($profdirs[$ct]) & "|") then continueloop
      if $showSysItems=0 and stringinstr(filename($profdirs[$ct]),"SUPPORT_",1) then continueloop
      $thisPIP=$profdirs[$ct]
      $thisUsers=""
      $profileSID="{orphaned}"
      for $userct=1 to $users[0][0]
        if $users[$userct][2]=$thisPIP then
          if $thisUsers <> "" then $thisUsers=$thisUsers & ","
          $thisUsers=$thisUsers & $users[$userct][0] & "\" & $users[$userct][1]
          $profileSID=$users[$userct][3]
        endif
      next ; $userct
      if $thisUsers <>"" then
        $lvVarlist= $lvVarlist & "|" & $thisUsers 
      endif
     ; check for large userlists ****************************
      $plv[$ct]=GUICtrlCreateListViewItem($lvVarlist,$lvProfiles)
      if $plv[$ct] >= $lvSize then
        $lvsize=$plv[$ct]+100
        ReDim $lvCtrl[$lvSize]
      endif
      $lvCtrl[$plv[$ct]]=$ct
      $plv[0]=$ct
    next ; $ct
    GUICtrlSendMsg($lvProfiles, 0x1000 + 30, 0, 270)
    GUICtrlSendMsg($lvProfiles, 0x1000 + 30, 1, 255)

    if $lvUsers<>-1 then
      GUICtrlDelete($lvUsers)
    endif

    $lvUsers = GUICtrlCreateListView ("    Host     |          User          |**|               Assigned Folder        | SID  ",10,70,530,150)
    dim $ulv[$users[0][0]+1]
    for $ct=1 to $users[0][0]
      ProgressSet((100*$ct)/$users[0][0],"Compiling user list")
      if $showSysItems=0 and stringinstr($systemUsers,"|" & $users[$ct][1] & "|") then continueloop
      if $showSysItems=0 and stringinstr($users[$ct][1],"SUPPORT_",1) then continueloop
      if $users[$ct][0]=@computername then
        $lvVarlist="Local"
      else
        $lvVarlist="Domain"
      endif
      $uFlags="  "
      $lvVarlist= $lvVarlist & "|" & $users[$ct][1]
      if $users[$ct][5]>0 then $uFlags=StringReplace($uFlags,1, "A")
      if $users[$ct][6]>0 then $uFlags=StringReplace($uFlags,2, "X")
      $lvVarlist= $lvVarlist & "|" & $uFlags
      $lvVarlist= $lvVarlist & "|" & $users[$ct][2]
      $lvVarlist= $lvVarlist & "|" & $users[$ct][3]
      $ulv[$ct]=GUICtrlCreateListViewItem($lvVarlist,$lvUsers)
      ; Expanding array...
      if $ulv[$ct] >= $lvSize then
        $lvsize=$ulv[$ct]+100
        ReDim $lvCtrl[$lvSize]
      endif
      $lvCtrl[$ulv[$ct]]=$ct
      $ulv[0]=$ct
    next

    GUICtrlSendMsg($lvUsers, 0x1000 + 30, 0, 100)
    GUICtrlSendMsg($lvUsers, 0x1000 + 30, 1, 160)
    GUICtrlSendMsg($lvUsers, 0x1000 + 30, 2, 25)
    GUICtrlSendMsg($lvUsers, 0x1000 + 30, 3, 240)
    GUICtrlSendMsg($lvUsers, 0x1000 + 30, 4, 280)
    GUISetState()
    $dirtyData=0
    ProgressOff()
  endif ; End of data reload/paint sections

  $msg = GUIGetMsg()
  Select
    Case $msg=0
      ;dummy value to prevent endless loop in interpreted mode 
    Case $msg = $btnTest
      testLogon()
    Case $msg = $btnHelp
      ShellExecute ("http://iwrconsultancy.co.uk/reprofiler")
    Case $msg = $btnRefresh
      $dirtyData = 3
    Case $msg = $btnAssign
      $dirtyData = 2
      prAssign()
    Case $msg = $btnDetach
      prDetach()
    Case $msg = $btnDelete
      prDelete()
    Case $msg = $btnProperties
      prProperties($prMode)
    Case $msg= $inpSysItems
      if GUICtrlRead($inpSysItems)= 1 then
        $showSysItems=1
      else
        $showSysItems=0
      endif
      $dirtyData=1
    Case $msg=$GUI_EVENT_CLOSE or $msg=$btnExit
      exitloop
  EndSelect
until 0

GUIDelete($ProfGUI)
exit


func testLogon()
  local $thisUser=$lvCtrl[GUICtrlRead($lvUsers)]
  local $thisProfile=$lvCtrl[GUICtrlRead($lvProfiles)]
  local $thisPath=$profdirs[$thisProfile]

  $thisDomain=$users[$thisUser][0]
  $thisName=$users[$thisUser][1]
  $thisSID=$users[$thisUser][3]
  $thisPIP=$users[$thisUser][2]
  if $thisUser=0 then
    msgbox(48,"Input Error"," Please select a Username from to test the logon with.",5)
    return -1
  endif
  $thisPwd=inputbox("Password Required for Test Logon","Please enter the password for user: " & $thisName,"","*")
  if @error > 0 then return 
  if $thisPwd="" then msgbox(16,"Unable to test account","Passwordless accounts cannot be logged on as secondary users, hence no test is possible.") 
  $runstr=@scriptfullpath & ' /logontest'
  $rtn=RunAs($thisName,$thisDomain,$thisPwd,1,$runstr)
  if @error=true or $rtn=0 then msgbox(32,"Error","Unable to log this user on. Please check the password is correct.",30)
  $thisPwd="noneofyourbusiness"
  $thisPwd=""
endfunc ;testLogon


func showTestLogon()

local $msg="User: " & @UserName & @crlf
$msg=$msg & "Domain: " & @LogonDomain & @crlf
$msg=$msg & "Profile: " & @UserprofileDir & @crlf
$msg=$msg & "Result: Success"
msgbox(0,"Logon Test",$msg,30)

endfunc ;testLogon


func prAssign()

  local $thisUser=$lvCtrl[GUICtrlRead($lvUsers)]
  local $thisProfile=$lvCtrl[GUICtrlRead($lvProfiles)]
  local $thisPath=$profdirs[$thisProfile]
  if FileExists($logfile) then FileDelete($logfile)

  if $thisUser=0 or $thisProfile=0 then
    msgbox(48,"Input Error"," Please select a User and Profile from the respective lists before clicking Assign.")
    return -1
  endif

  select
  case ($profdirs[$thisProfile]=@userprofiledir) 
    $info="You are assigning a user to a profile which is currently in-use. Once completed you should RESTART the computer before attempting to test the result. Note that logging off the current user may not be sufficient, as this does not always fully unload the associated profile. Also be aware that if two users are assigned to the same profile, both accounts must never log-on simltaneously." & @lf & @lf & " - Do you wish to proceed?"
    local $msg=msgbox(52,"Please Note:", $info)
    $info=""
    if $msg <>6 then return 2
;  case @username=$users[$thisUser][1] 
    case $users[$thisUser][5] > 0 
    $info="You are attempting to change the profile assignment for an active user. Depending on circumstances, this may or may not succeed. It is suggested that you take steps to log the user off, or if that is not possible, to restart the computer and use a different logon. If you elect to proceed with this change now, you should restart the computer immediately on completion." & @lf & @lf & " - Do you wish to proceed?"
    local $msg=msgbox(52,"Please Note:", $info)
    $info=""
    if $msg <>6 then return 2
  case else
    local $info="Do you wish to assign the User Account named:" & @crlf & $users[$thisUser][1] & @crlf & "As a trustee of the data stored in the profile folder:" & @crlf & $profdirs[$thisProfile]
    local $msg=msgbox(36,"Please Confirm your Choice:", $info)
    $info=""
    if $msg <>6 then return 2
  
  endselect

; Initialise new user if running Vista/7/8/10, as uninitialised users cannot have a profile assigned on these platforms:
 
  do
    $thisDomain=$users[$thisUser][0]
    $thisName=$users[$thisUser][1]
    $thisSID=$users[$thisUser][3]
    $thisbSID=sid2bin($thisSID)
    $thisPIP=$users[$thisUser][2]
    if stringinstr("WIN_2003|WIN_XP|WIN_2000", @OSVersion) then exitloop
    if $thisPIP <> "" then exitloop
    $thisPwd=inputbox("User requires initialising","This user has not previously logged-on to this computer, or has been Detached from the profile since last logon. Please enter the user's password so that the account can be initialised")
    if @error>0 then exitloop
    $runstr=@comspec & " /c"
    $rtn=RunAs($thisName,$thisDomain,$thisPwd,1,$runstr,@ScriptDir,$doswindow)
    sleep(1000)
    getprofiles()
    $piploc = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList\" & $thisSID
    $users[$thisUser][2] = RegRead($piploc,"ProfileImagePath")
  until 0
    $thisDomain=$users[$thisUser][0]
    $thisName=$users[$thisUser][1]
    $thisSID=$users[$thisUser][3]
    $thisPIP=$users[$thisUser][2]
;    $users[$thisUser][2] = RegRead($piploc,"ProfileImagePath")

  $profsz=regread("HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList","ProfilesDirectory")
  $thisAPath=$thisPath
  if stringinstr($thisPath,"\")=0 then $thisPath = $profsz & "\" & $thisPath
  ; I see no reason to use an env string to determine location, as profiles are not relocatable anyway. But, when in Rome...  
  $thisPath=stringreplace($thisPath,envget("SystemDrive"),"%SystemDrive%",1)
  $piploc = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList\" & $thisSID
  $thisPIP=$thisPath
  
  ; Check for an  existing key with a temp PIP and warn user to log out before proceeding:
  $tempPIP=RegRead($piploc,"ProfileImagePath")
  if stringinstr($tempPIP,"temp") then
    $msg=msgbox(52,"Problem - Account in use", "This account is active with a temporary profile. If possible you should log this user off before trying to resssign the profile. Proceed anyway? ")
    if $msg <>6 then return 0
  endif
  ; Ideally should add check for any logon, not just temp. **

  ProgressOn ( "Reprofiling...", "This may take some time", "Please be patient" )
  ProgressSet(2,"-removing if present","Checking for temporary profile")
  ; Check for existence of Vista/7 '.bak' registry key:
  $thisPIPBak=RegRead($piploc & ".bak","ProfileImagePath")
  if @error=0 then 
    ; Probably best just to remove and re-create: 
    RegDelete($piploc & ".bak")
  endif

;  Check for an existing key with missing PIP entry and remove it if present: 
;  (replaced by next section) 
;  $existingKey=RegRead($piploc)
;  if @error=0 then
;    $existingPIP=RegRead($piploc","ProfileImagePath")
;    if @error then 
;      RegDelete($piploc)
;    endif
;  endif
  
 ; What follows is an undocumented hack which causes profile to be loaded if present, recreated from default if not:
  RegDelete($piploc,"ProfileLoadTimeHigh") 
  RegDelete($piploc,"ProfileLoadTimeLow")
  RegDelete($piploc,"RefCount") 
  RegDelete($piploc,"Sid") 
#cs
"Flags"=dword:00000000
"State"=dword:00000100
"CentralProfile"=""
"ProfileLoadTimeLow"=dword:8783204a
"ProfileLoadTimeHigh"=dword:01cdabc9
"RefCount"=dword:00000001
"RunLogonScriptSync"=dword:00000000
"OptimizedLogonStatus"=dword:0000000b
#ce
 ProgressSet(10,"Writing registry links","Associating profile")
; This is zero for non-admin profile, but is self-configuring... 
  RegWrite($piploc,"State","REG_DWORD",0x00000100) 
; This self-configues to a LAN path for a roaming profile... 
  RegWrite($piploc,"CentralProfile","REG_SZ","")
; These are zero on Vista and its spawn, contain hi/lo word of last load time on XP...  
  RegWrite($piploc,"ProfileLoadTimeLow","REG_DWORD",0x00000000) 
  RegWrite($piploc,"ProfileLoadTimeHigh","REG_DWORD",0x00000000) 
; This is undocumented but apparently causes trouble if >1 ... 
  RegWrite($piploc,"RefCount","REG_DWORD",0x00000001) 
; Purpose unknown... 
  RegWrite($piploc,"OptimizedLogonStatus","REG_DWORD",0x0000000b) 
; Binary representation of SID which is this registry key's name...
  RegWrite($piploc,"Sid","REG_BINARY",$thisbSID) 
; Essential part...  
  RegWrite($piploc,"Flags","REG_DWORD",0x0) ;0xFFFFFFFF) 
  RegWrite($piploc,"ProfileImagePath","REG_EXPAND_SZ",$thisPIP)
  if @error=0 then
    $result= "Change ProfileImagePath for this user... OK" & @CRLF
  else
    $result= "Change ProfileImagePath for this user... FAIL" & @CRLF
  endif
  ProgressSet(20,$result,"Registry links..")
  sleep(1000)
  $thisHive=$thisAPath & "\NTUSER.DAT"
  $thisClassHive=$thisAPath & "\Local Settings\Application Data\Microsoft\Windows\UsrClass.dat"
  if $thisAPath<>@UserProfileDir then 
    $thisHKU=$thisSID
    $rlh=True
    $rlh1=RegLoadHive($thisHKU, $thisHive)
    $rlh2=RegLoadHive($thisHKU & "_Classes", $thisClassHive)
    if not $rlh1 then 
     $thisHKU="Reprofiler_HKU"
     $rlh1=RegLoadHive($thisHKU, $thisHive)
     $rlh2=RegLoadHive($thisHKU & "_Classes", $thisClassHive)
    endif
    $regUserSection='HKEY_USERS\' & $thisHKU
    ; msgbox(0,$thisAPAth & "apath>activeprofile" & @UserProfileDir,$thisHKU & "sid>hive" & $thisHive,10)
    if not $rlh1 then 
      ProgressOff()
      msgbox(0,"User-Registry Load Failure","The attempt to load the registry-section for this user failed. This may be due to the useraccount already being active under a separate thread. This may result in permissions problems for the user, or problems saving settings under that account. It is suggested that you restart the computer and repeat the profile-assignment, ensuring that the useraccount is NOT active.",60 ) 
    endif
  Else
    $regUserSection='HKEY_CURRENT_USER'
    $rlh=False
    $rlh1=False
    $rlh2=False
    ; msgbox(0,"No Hive Load - " & $thisAPath & " - "  & @UserProfileDir,$rlh1 & " " & $rlh2) ;+msg
  EndIf
  ProgressSet(30,"May take time if there are many files","Changing file ownerships")
  if (stringinstr("WIN_2003|WIN_XP|WIN_2000", @OSVersion)) OR ($useXCACLS=0) then
    $result = $result & "Change ownership of profile contents.. "
    $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ownr "n:' & $thisSID & ';s:y"  -actn setowner -rec cont_obj -log ' & $logfile
    $rtn1 = RunWait($Runstr,@scriptdir,$doswindow)
    if $rtn1=0 then 
      $rtn1="OK"
    else
      $rtn1="Warning: " & $rtn1
    endif
    ; Revert profile root ownership to Administrators group. Not sure why, but Microsoft do it like this so.. 
    $admingroupSID="S-1-5-32-544"
    $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ownr "n:' & $admingroupSID & ';s:y"  -actn setowner -rec no -log ' & $logfile
    $rtn1x = RunWait($Runstr,@scriptdir,$doswindow)
  else
  ; Because of Vista/7's cyclic symlinks, we use ICACLS here:
    $result = $result & "Add user ACL to profile contents with ICACLS.. "
    $runstr = 'cmd /c icacls ' & $thisPIP & ' /grant *' & $thisSID & ':F /T /C >>icacls.' & $logfile
    $rtn1 = RunWait($Runstr,@scriptdir,$doswindow)
    if $rtn1=1 then 
      $rtn1="OK"
    else
      $rtn1="Warning: " & $rtn1
    endif
  endif
  ProgressSet(50, "Result:" & $rtn1,"Ownership change completed")
  $result = $result & $rtn1 & @CRLF
  sleep(1000)
  ProgressSet(60,"This may also take some time" , "Adding user to file permissions")
  ; Add user permissions...
  $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ace "n:' & $thisSID & ';s:y;p:full"  -actn ace -log ' & $logfile
  $result = $result & "Add user as trustee of profile root... "
  $rtn2 = RunWait($Runstr,@scriptdir,$doswindow)
  if $rtn2=0 then $rtn2="OK"
  $result = $result & $rtn2 & @CRLF
  ProgressSet(80,"Adding user to permissions", "Profile registry hive..")
  ; Add registry permissions... 
  ; recursion added to overcome Windows 10 registry inheritance issues.
  $runstr = 'cmd /c setacl -ot reg -on "' & $regUserSection & '" -ace "n:' & $thisSID & ';s:y;p:full"  -actn ace -rec yes -log ' & $logfile
  $result = $result & "Add user as trustee of registry hive... "
  $rtn3 = RunWait($Runstr,@scriptdir,$doswindow)
  if $rtn3=0 then $rtn3="OK"
  $result = $result & $rtn3 & @CRLF

; Ensure correct ownership of uer hive registry keys (added mainly for sake of Windows 10 issues)
  $runstr = 'cmd /c setacl -ot reg -on "' & $regUserSection & '" -ownr "n:' & $admingroupSID & ';s:y"  -actn setowner -rec yes -log ' & $logfile
  $result = $result & "Set owner of user registry keys to be Administrators group... "
  $rtn3 = RunWait($Runstr,@scriptdir,$doswindow)
  if $rtn3=0 then $rtn3="OK"
  $result = $result & $rtn3 & @CRLF
  
  ; Classes permissions don't seem to be necessary..  
  ;$runstr = 'setacl -ot reg -on "' & $regUserSection & '_Classes" -ace "n:' & $thisSID & ';s:y;p:full"  -actn ace -silent -log ' & $logfile
  ;$result = $result & "Add user as trustee of classes registry hive... "
  ;$rtn4 = RunWait($Runstr,@scriptdir,$doswindow)
  ;if $rtn4=0 then $rtn4="OK"
  ;$result = $result & $rtn4 & @CRLF
  ProgressOff()
  $ruh1="undefined"
  $ruh2="undefined"
  if $rlh1 then $ruh1=RegUnLoadHive($thisHKU)
  if $rlh2 then $ruh2=RegUnLoadHive($thisHKU & "_Classes")
  ; msgbox(0,"Hive Unload",$ruh1 & " " & $ruh2) ;+msg

  $result = $result & @CRLF & "Do you wish to see the log file?"

  $msg=msgbox (68,"Profile Reassigned",$result)
  if $msg=6 then
    $runstr="notepad " & $logfile
    Run($runstr)
  endif

endfunc   ;==>prAssign

func getprofiles($_pathtoscan="")

  $_listidx=0

  if $_pathtoscan="" then
    $profdir=regread("HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList","ProfilesDirectory")
    $profdir=StringReplace($profdir,"%SystemDrive%",envget("SystemDrive"))
    $_pathtoscan=$profdir
  endif

  global $profileRoot=$_pathtoscan

  if stringright($_pathtoscan,1)<>"\" then $_pathtoscan = $_pathtoscan & "\"

  global $profdirs[10000]

  $_thisMask = $_pathToScan & "*.*"
  $_spSearch = FileFindFirstFile ( $_thisMask )

  While 1
    If $_spSearch = -1 then ExitLoop
    $_file = FileFindNextFile($_spSearch)
    If @error Then ExitLoop

    $_FQSrcName = $_pathtoscan &  $_file
    $_srcFileAttribs = FileGetAttrib($_FQSrcName)

    if stringinstr($_srcFileAttribs,"D") then
      $_listidx=$_listidx+1
      $profdirs[$_listidx]=  $profileRoot & "\" & $_file
    endif

  WEnd
  $profdirs[0]=$_listidx
  ProgressOff()
endfunc   ;==>getprofiles

func getusers()
  
  ProgressOn ( "Reprofiler", "Retrieving user list..", "On a large Active Directory this may take time" )
  ; Return string array of useraccounts containing Domain, Name, ImagePath, SID, FolderExists
  ; Element 0,0 is total accounts.

  $wbemFlagReturnImmediately = 0x10
  $wbemFlagForwardOnly = 0x20
  $colItems = ""
  $strComputer = "localhost"
  $objWMIService = ObjGet("winmgmts:\\" & $strComputer & "\root\CIMV2")
  if @error then
   msgbox(16,"WMI Error","Unable to connect to the Windows Management Interface service. This may be due to the WMI service having been disabled, or due to a third-party firewall or other security software which is preventing or interfering-with access. We suggest as a starting-point that you run services.msc and check the condition of the WMI service." & @crlf & @crlf & "Unable to continue, therefore Exiting.",60)
   Exit
  endif
  $colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_UserAccount", "WQL", $wbemFlagReturnImmediately + $wbemFlagForwardOnly)

  $uasize=100
  global $users[$uasize][8]
  $ct=0
  $users[0][7]=0
  #cs
    0=domain
    1=name
    2=pip
    3=sid
    4=folderexists
    5=isLoggedOn  
    6=broken
    7=roaming profile location
  #ce

  If IsObj($colItems) then
    For $objItem In $colItems
      ProgressSet(mod($ct, 100),$ct & " users found")
      $ct=$ct+1
      if $ct >= $uasize then 
        $uasize=$uasize+100
        ReDim $users[$uasize][8]
      endif
      $users[$ct][0] = $objItem.Domain
      $users[$ct][1] = $objItem.Name
      $users[$ct][3] = $objItem.SID
      $users[$ct][5] = 0
      $users[$ct][6] = 0
      $piploc = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList\" & $users[$ct][3]
      $users[$ct][2] = RegRead($piploc,"ProfileImagePath")
      $users[$ct][7] = RegRead($piploc,"CentralProfile")
      if $users[$ct][7]<>"" then $users[0][7]=1
      if @error or StringInStr($users[$ct][2],"\TEMP") then 
        ; msgbox(0,"pip","notfound")
        $piploc = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList\" & $users[$ct][3] & ".bak"
        $tmp = RegRead($piploc,"ProfileImagePath")
        if @error=0 then 
            $users[$ct][2] = $tmp
            $users[$ct][6] = 1
        endif
      endif
      $users[$ct][2]=StringReplace($users[$ct][2],"%SystemDrive%",envget("SystemDrive"))
      if stringlen($users[$ct][2])>0 then
        if FileExists($users[$ct][2] & "\NTUSER.DAT") then
          $users[$ct][4]=1
        else
          $users[$ct][4]=0
        endif
      endif
      ;Find out if account is logged-on: (To save time, only do for first 99 users)     
      $users[$ct][5]=0
      if $ct < 100 then 
        $LogonItems = $objWMIService.ExecQuery("SELECT * FROM Win32_LoggedOnUser", "WQL", $wbemFlagReturnImmediately + $wbemFlagForwardOnly)
        If IsObj($LogonItems) then
          For $LogonItem In $LogonItems
          $thisName=$LogonItem.Antecedent
           ; msgbox(0,"logon",$thisname)
           if stringinstr($LogonItem.Antecedent,'name="' & $users[$ct][1] & '"') then 
             $users[$ct][5]=1
           endif 
          next
        endif
      endif
    Next
    $users[0][0]= $ct
  Else
    Msgbox(16,"WMI Error","The WMI service is required for this tool to function, and does not appear to be running." )
  Endif
  ProgressOff()  
endfunc   ;==>getusers

func filename ($_pathtostrip)
  return stringmid($_pathtostrip,stringinstr($_pathtostrip,"\",0,-1) +1 ,255)
endfunc   ;==>filename


; === RegLoadHive ===
; Loads a ntuser.dat file as a registry hive
; Requires SetPrivilege function.
;
; Inputs:	$hiveName		- name for the hive
;			$NTUSER_datFile	- full path to ntuser.dat file to load
;			$RLH_key		- (optional) root for hive (defaults to HKU)
;
; Returns:	1 - Successful
;			0 - Error (sets @error)

Func RegLoadHive($hiveName, $NTUSER_datFile, $RLH_key = "HKU")
  If Not (@OSTYPE=="WIN32_NT") Then
    SetError(-1)
    Return 0
  EndIf
  Local $HKEY_LOCAL_MACHINE = 0x80000002
  Local $HKEY_USERS = 0x80000003
  Local $SE_RESTORE_NAME = "SeRestorePrivilege"
  Local $SE_BACKUP_NAME = "SeBackupPrivilege"
  Local $RLH_ret
  Local $aPriv[2]
  If $RLH_key = "HKLM" Then
    $RLH_key = $HKEY_LOCAL_MACHINE
  ElseIf $RLH_key = "HKU" Then
    $RLH_key = $HKEY_USERS
  Else
    SetError(-2)
    Return 0
  EndIf
  $aPriv[0] = $SE_RESTORE_NAME
  $aPriv[1] = $SE_BACKUP_NAME
  SetPrivilege($aPriv,1)
  $RLH_ret = DllCall("Advapi32.dll","int","RegLoadKey","int",$RLH_key,"str",$hiveName,"str",$NTUSER_datFile)
  SetError($RLH_ret[0])
  Return Not $RLH_ret[0]
EndFunc   ;==>RegLoadHive
; === END RegLoadHive ===


; === RegUnloadHive ===
; Unloads a registry hive
; Requires SetPrivilege function.
;
; Inputs:	$hiveName		- name for the hive
;			$RLH_key		- (optional) root for hive (defaults to HKU)
;
; Returns:	1 - Successful
;			0 - Error (sets @error)
Func RegUnloadHive($hiveName, $RUH_key = "HKU")
  If Not (@OSTYPE=="WIN32_NT") Then
    SetError(-1)
    Return 0
  EndIf
  Local $HKEY_LOCAL_MACHINE = 0x80000002
  Local $HKEY_USERS = 0x80000003
  Local $RUH_ret
  If $RUH_key = "HKLM" Then
    $RUH_key = $HKEY_LOCAL_MACHINE
  ElseIf $RUH_key = "HKU" Then
    $RUH_key = $HKEY_USERS
  Else
    SetError(-2)
    Return 0
  EndIf
  $RUH_ret = DllCall("Advapi32.dll","int","RegUnLoadKey","int",$RUH_key,"Str",$hiveName)
  Return Not $RUH_ret[0]
EndFunc   ;==>RegUnloadHive
; === RegUnloadHive ===


; === SetPrivilege ===
; Special function for use with registry hive functions
Func SetPrivilege( $privilege, $bEnable )
  Local $TOKEN_ADJUST_PRIVILEGES = 0x0020
  Local $TOKEN_QUERY = 0x0008
  Local $SE_PRIVILEGE_ENABLED = 0x0002
  Local $hToken, $SP_auxret, $SP_ret, $hCurrProcess, $nTokens, $nTokenIndex, $priv
  $nTokens = 1
  $LUID = DLLStructCreate("dword;int")
  If IsArray($privilege) Then    $nTokens = UBound($privilege)
  $TOKEN_PRIVILEGES = DLLStructCreate("dword;dword[" & (3 * $nTokens) & "]")
  $NEWTOKEN_PRIVILEGES = DLLStructCreate("dword;dword[" & (3 * $nTokens) & "]")
  $hCurrProcess = DLLCall("kernel32.dll","hwnd","GetCurrentProcess")
  $SP_auxret = DLLCall("advapi32.dll","int","OpenProcessToken","hwnd",$hCurrProcess[0], _
      "int",BitOR($TOKEN_ADJUST_PRIVILEGES,$TOKEN_QUERY),"int*",0)
  if @error then 
    msgbox(16,"Error","Unable to set permissions on user registry")
    return 0
  endif
  If $SP_auxret[0] Then
    $hToken = $SP_auxret[3]
    DLLStructSetData($TOKEN_PRIVILEGES,1,1)
    $nTokenIndex = 1
    While $nTokenIndex <= $nTokens
      If IsArray($privilege) Then
        $priv = $privilege[$nTokenIndex-1]
      Else
        $priv = $privilege
      EndIf
      $ret = DLLCall("advapi32.dll","int","LookupPrivilegeValue","str","","str",$priv, _
          "ptr",DLLStructGetPtr($LUID))
      If $ret[0] Then
        If $bEnable Then
          DLLStructSetData($TOKEN_PRIVILEGES,2,$SE_PRIVILEGE_ENABLED,(3 * $nTokenIndex))
        Else
          DLLStructSetData($TOKEN_PRIVILEGES,2,0,(3 * $nTokenIndex))
        EndIf
        DLLStructSetData($TOKEN_PRIVILEGES,2,DllStructGetData($LUID,1),(3 * ($nTokenIndex-1)) + 1)
        DLLStructSetData($TOKEN_PRIVILEGES,2,DllStructGetData($LUID,2),(3 * ($nTokenIndex-1)) + 2)
        DLLStructSetData($LUID,1,0)
        DLLStructSetData($LUID,2,0)
      EndIf
      $nTokenIndex += 1
    WEnd
    $ret = DLLCall("advapi32.dll","int","AdjustTokenPrivileges","hwnd",$hToken,"int",0, _
        "ptr",DllStructGetPtr($TOKEN_PRIVILEGES),"int",DllStructGetSize($NEWTOKEN_PRIVILEGES), _
        "ptr",DllStructGetPtr($NEWTOKEN_PRIVILEGES),"int*",0)
    $f = DLLCall("kernel32.dll","int","GetLastError")
  EndIf
  $NEWTOKEN_PRIVILEGES = 0
  $TOKEN_PRIVILEGES = 0
  $LUID = 0
  If $SP_auxret[0] = 0 Then Return 0
  $SP_auxret = DLLCall("kernel32.dll","int","CloseHandle","hwnd",$hToken)
  If Not $ret[0] And Not $SP_auxret[0] Then Return 0
  return $ret[0]
EndFunc   ;==>SetPrivilege
; === SetPrivilege ===


func ReLaunch()

  ; (Not used with later script versions)
  if isAdmin() then return 1

  $msg=MsgBox(52,"Administrative rights necessary","This utility needs adminstrative rights in order to perform its function, but has been started under an account with limited rights. Do you wish to attempt to re-start the app under the Administrator account?")
  if $msg=6 then
    $pwd=inputbox("Password Required","Please enter the Administrator password for this computer")
    RunAs("Administrator",@computername,$pwd,0,@scriptfullpath,@scriptdir)
    exit
  endif

  return 0
endfunc   ;==>ReLaunch

func prDelete()
  local $thisUser=$lvCtrl[GUICtrlRead($lvUsers)]
  local $thisProfile=$lvCtrl[GUICtrlRead($lvProfiles)]
  local $thisPath=$profdirs[$thisProfile]
  local  $thisDomain=$users[$thisUser][0]
  local  $thisName=$users[$thisUser][1]
  local  $thisSID=$users[$thisUser][3]
  local  $thisPIP=$users[$thisUser][2]
  if stringlen($thisPath)<5 then
    msgbox(64,"No action taken","Nothing selected to erase. Please highlight a profile-folder first.",10 )
    return 0
  endif
  if stringinstr(@AppDataDir,$thisPath) then
    msgbox(16,"Foot-Shooting Attempt Detected!","You are attempting to delete the active user's profile. If successful, this would cause system instability. Action blocked.",10 )
    return 0
  endif
  $msg=msgbox(52,"Caution - action removes data","Permanently ERASE " & $thisPath & "  and all of its contents?." & @cr & @cr & "This folder may contain personal documents, pictures, email, etc. Do not proceed unless you are CERTAIN the data it contains is no longer needed." & @cr & @cr & "Under Windows XP it is generally OK to delete active profiles, in which case they will be re-created from the Default profile at next log-on. " & @cr & @cr & "However, under Vista or Windows 7, deleting a profile with a user still attached may lead to trouble with the account. "& @cr & @cr & " Proceed? ")
  if $msg=6 then
    if $allowDelete<>"YES" then
      $allowDelete=inputbox("Delete Data","To confirm this action, please type YES into the box below. ")
      if $allowDelete <> "YES" then return 0
    endif
    $runstr="cmd /c rd /s /q " & $thisPath
    RunWait($runstr,@ScriptDir,$doswindow)
    $result=DirGetSize($thisPath)
    if $result=-1 then
      msgbox(64,"Profile Deleted","The selected profile-folder has been removed from the hard-disk.")
    else
      msgbox(48,"Profile Delete Attempted, " & $result / 1024 / 1024 & "MB Data Remaining","The attempt to remove the profile has not been entirely successful. This may be due to files being held-open by useraccounts which are presently logged-on, or to network shares within the profile-folder being accessed from other computers.It is suggested that a freah attempt is made after a restart, ensuring that only the Administrator account is allowed to log-on."  )
    endif
    $dirtyData=2
  endif
endfunc   ;==>prDelete

func prDetach()
  local $thisUser=$lvCtrl[GUICtrlRead($lvUsers)]
  local $thisProfile=$lvCtrl[GUICtrlRead($lvProfiles)]
  local $thisPath=$profdirs[$thisProfile]
  local  $thisDomain=$users[$thisUser][0]
  local  $thisName=$users[$thisUser][1]
  local  $thisSID=$users[$thisUser][3]
  local  $thisPIP=$users[$thisUser][2]
  local  $thisID=$thisDomain & "\" & $thisName
  local $result=""
  if FileExists($logfile) then FileDelete($logfile)

  $piploc = "HKLM\Software\Microsoft\Windows NT\CurrentVersion\ProfileList\" & $thisSID
  $confPIP= RegRead($piploc,"ProfileImagePath")

  if stringlen($thisPath)<5 or stringlen($thisName)=0 then
    msgbox(48,"Items Not Selected","Unable to proceed. Please highlight a user-account and a profile-folder which you wish to dissociate from each other, then try again.")
    return 0
  endif

  if $thisPIP <> $thisPath then
    msgbox(48,"Not Associated","The specified user-account ("&$thisName&") is not presently a trustee of the selected data folder ("&$thisPath&") therefore no action has been taken.")
    return 0
  endif

  $msg=msgbox(36,"Detach profile from useraccount","Do you wish to cancel the ownership of the data stored in " & @cr & $thisPIP & @cr & " by user " & @cr & $thisDomain & "\" & $thisName & " ?" & @cr & "(This action will not delete data, but it might make the data inaccessible to the user.)")
  if $msg <>6 then return 0
  if $thisSID="" then return 0 ; Precaution against deleting profile-root key. 
  
  if @osbuild>5000 then 
    RegDelete($piploc)
  else
    RegDelete($piploc,"ProfileImagePath")
  endif
  ; Remove permissions from profile (added 1.0):
  ; Would rather use SIDs here to ensure correct action with multilingual character sets, but seems that SetACL doesn't support them in this comamnd.. 
    $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -trst "n1:' & $thisID & ';ta:remtrst;w:dacl,sacl"  -actn trustee -log ' & $logfile
  ; We could optionally set perms to read instead.. 
  ; $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ace "n:' & $thisSID & ';s:y;p:read"  -actn ace -log ' & $logfile

  $rtn1 = RunWait($runstr,@scriptdir,$doswindow)
  if $rtn1=0 then 
    $rtn1="Remove file permissions.. OK"
  else
    $rtn1="Warning: " & $rtn1
  endif
  $result = $result & $rtn1 & @CRLF
   ; Change ownership of profile data to first attached user found,
   ; If no attached users, set to Administrators group. 
  $admingroupSID="S-1-5-32-544"
  $resetSID=$admingroupSID
  ; Search userlist for first account with this PIP:
  for $userct=1 to $users[0][0]
   if $users[$userct][2]=$thisPIP then
     $resetSID= $users[$userct][3] 
     exitloop ; userct
   endif
  next ; $userct
  $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ownr "n:' & $resetSID & ';s:y"  -actn setowner -rec cont_obj -log ' & $logfile
  $rtn1x = RunWait($Runstr,@scriptdir,$doswindow)
  ; Set profile root back to administrators ownership as per Microsoft security model;
  $runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ownr "n:' & $admingroupSID & ';s:y"  -actn setowner -rec none -log ' & $logfile
  $rtn2x = RunWait($Runstr,@scriptdir,$doswindow)
  
  ; Remove registry permissions... 
  $thisHive=$thisPIP & "\NTUSER.DAT"
  if $thisPath<>@UserProfileDir then 
    $thisHKU=$thisSID
    $rlh=True
    $rlh1=RegLoadHive($thisHKU, $thisHive)
    if not $rlh1 then 
     $thisHKU="Reprofiler_HKU"
     $rlh1=RegLoadHive($thisHKU, $thisHive)
    endif
    $regUserSection='HKEY_USERS\' & $thisHKU
     ; msgbox(0,$thisPath & "path>activeprofile" & @UserProfileDir,$thisHKU & "sid>hive" & $thisHive,120)
    if not $rlh1 then 
      msgbox(0,"User-Registry Load Failure","The attempt to load the registry-section for this user failed. This may be due to the useraccount already being active under a separate thread. This may result in permissions problems for the user, or problems saving settings under that account. It is suggested that you restart the computer and repeat the profile-assignment, ensuring that the useraccount is NOT active.",60 ) 
    endif
  else
    $regUserSection='HKEY_CURRENT_USER'
    $rlh=False
  endif
  ; Would rather use SIDs here to ensure correct action with multilingual character sets, but seems that SetACL doesn't support them in this comamnd.. 
  $runstr = 'cmd /c setacl -ot reg -on "' & $regUserSection & '" -trst "n1:' & $thisID & ';ta:remtrst;w:dacl,sacl"  -actn trustee -log ' & $logfile
  ; We could optionally set perms to read instead.. 
  ;$runstr = 'cmd /c setacl -ot file -on "' & $thisPIP & '" -ace "n:' & $thisSID & ';s:y;p:n"  -actn ace -log ' & $logfile
  $rtn2 = RunWait($runstr,@scriptdir,$doswindow)
  if $rtn2=0 then 
    $rtn2="Remove registry permissions.. OK"
  else
    $rtn2="Warning: " & $rtn2
  endif
  $result = $result & $rtn2 & @CRLF

  if $rlh then 
    RegUnloadHive($thisHive)
  endif

  $result = $result & @CRLF & "Do you wish to see the log file?"

  $msg=msgbox (68,"Profile Detached",$result)
  if $msg=6 then
    $runstr="notepad " & $logfile
    Run($runstr)
  endif
  
  $dirtyData=2
endfunc   ;==>prDetach

func prProperties($_mode="profile")
  local $thisUser=$lvCtrl[GUICtrlRead($lvUsers)]
  local $thisProfile=$lvCtrl[GUICtrlRead($lvProfiles)]
  local $thisPath=$profdirs[$thisProfile]
  local  $thisDomain=$users[$thisUser][0]
  local  $thisName=$users[$thisUser][1]
  local  $thisSID=$users[$thisUser][3]
  local  $thisPIP=$users[$thisUser][2]
  local $thisBAK=""
  local $thisON=""
  if $users[$thisUser][6] then  $thisBAK="Warning: Temporary profile - Indicates problem with associated profile, or with registry ProfileImagePath pointer." & @lf
  if $users[$thisUser][5] then $thisON="Note: This account is active. Best to log off before making changes." & @lf
  $pParams=""
  $uParams=""
  if stringlen($thisPath)<5 then
   $pParams="Unable to get profile information, possibly none selected from list, or data is incomplete." & @lf
  endif
  $size   = DirGetSize($thisPath,1)
  $tLL =  FileGetTime($thisPath & "\NTUSER.DAT", 0)
  if  @error =0 Then
   $lastLogon=$tLL[0] & "/" & $tLL[1] & "/" & $tLL[2]
    if IsArray($size) Then
     $pParams="Selected Profile Folder Information" & @lf & "Path: " & $thisPath & @lf & "Size: " & round($size[0]/1024/1024) & "MB" & @LF  & "Files: " & $size[1] & @LF & "Dirs: " & $size[2] & @LF & "Last Interactive Logon (YMD): " & $lastLogon
    endif
  else
    $pParams="No information available, either no profile selected or this profile has never been logged-on interactively." & @lf
  EndIf
 
  if $thisName <>"" then  
  if $thisPIP="" then $thisPIP="None Allocated"
  $uParams="Selected User Account Information" & @lf & "Name: " & $thisName & @LF  & "Domain: " & $thisDomain & @LF & "SID(GUID): " & $thisSID & @LF & "Profile Image Path: " & $thisPIP & @LF & $thisBAK & $thisON
  else
   $uParams="Unable to get user information, possibly none selected from list, or account is damaged." & @lf
  endif
 
   Msgbox(64,"User and Profile Information",$UParams & @lf & "-------------" & @lf & @lf & $pParams,120 )

endfunc   ;==>prProperties
 
Func WMIDateStringToDate($dtmDate)

	Return (StringMid($dtmDate, 5, 2) & "/" & _
	StringMid($dtmDate, 7, 2) & "/" & StringLeft($dtmDate, 4) _
	& " " & StringMid($dtmDate, 9, 2) & ":" & StringMid($dtmDate, 11, 2) & ":" & StringMid($dtmDate,13, 2))
EndFunc 


Func sid2str($bSID)
; Converts a  binary SID to a string
	Local $tData = DllStructCreate("byte SID[256]")
    DllStructSetData($tData, "SID", $bSID)
	$sSID = _Security__SidToStringSid(DllStructGetPtr($tData, "SID"))
	Return $sSID
EndFunc  

Func sid2bin($sSID)
	Local $aCall = DllCall("advapi32.dll", "bool", "ConvertStringSidToSidW", "wstr", $sSID, "ptr*", 0)
	If @error Or Not $aCall[0] Then Return SetError(1, @extended, 0)
	Local $pSID = $aCall[2]
	Local $tBuffer = DllStructCreate("byte Data[" & _Security__GetLengthSid($pSID) & "]", $pSID)
	Local $tSID = DllStructCreate("byte Data[" & DllStructGetSize($tBuffer) & "]")
	DllStructSetData($tSID, "Data", DllStructGetData($tBuffer, "Data"))
	$bSID=DllStructGetData($tSID,"Data")
	_WinAPI_LocalFree($pSID)
	Return $bSID
EndFunc  

Func GetComputerDomain($strComputer = "localhost")
  local $thisComputerDomain=@Computername
  local $thisComputerDomainRole=0
  $objWMIService = ObjGet("winmgmts:\\" & $strComputer & "\root\CIMV2")
  if @error then Exit
  $colItems = $objWMIService.ExecQuery("SELECT * FROM Win32_ComputerSystem", "WQL", 0x30)
  If IsObj($colItems) then
    For $objItem In $colItems
       $thisComputerDomain = $objItem.Domain
       $thisComputerDomainRole = $objItem.DomainRole
    next
  endif  
  ; Fix issue that computername, NOT workgroup is standalone logon prefix; 
  if $thisComputerDomainRole=0 then $thisComputerDomain=@Computername
  Return $thisComputerDomain  
endfunc    